Include "blitzsys.bb"
Include "Draw3D.bb"

Global Window=DLLFindBlitzRuntimeHwnd("Egypt-Clock")
DLLSetWindowZOrder(Window,HWND_NOTOPMOST)

SeedRnd MilliSecs()
Graphics3D  320,240,0,2
SetBuffer BackBuffer()

Camera=CreateCamera()

DrawInit3D(Camera)
Origin(320,240)

Dim GFX_Grab(10)
GFX1=LoadImage3D("gfx01.png",2)
GFX_Grab(0)=GrabImage3D(GFX1,2,66,60,60,6,1)
GFX_Grab(1)=GrabImage3D(GFX1,0,0,64,64,5,5)
GFX_Grab(2)=GrabImage3D(GFX1,66,2,62,94)
GFX_Grab(3)=GrabImage3D(GFX1,128,0,32,32,0.15,0.15)
GFX_Grab(4)=GrabImage3D(GFX1,160,0,32,32,0.15,0.15)
;Besonderheiten
GFX_Grab(5)=GrabImage3D(GFX1,192,0,318,64);Bergstadt
GFX_Grab(6)=GrabImage3D(GFX1,128,32,32,32,0.15,0.15);Sternschnuppen
GFX_Grab(7)=GrabImage3D(GFX1,192,64,318,64);Paris
GFX_Grab(8)=GrabImage3D(GFX1,192,128,318,64);London
GFX_Grab(9)=GrabImage3D(GFX1,192,192,318,64);Berlin

GFX_Grab(10)=GrabImage3D(GFX1,128,64,64,64);Sonne

Font=LoadFont3D("font.png",2)
SetFont3D 1,1,-2,0

Light=CreateLight()

MoonTex=LoadTexture("gfx02.png")
Moon=CreateSphere(24)
EntityTexture Moon,MoonTex
EntityOrder Moon,-1024

iBothEyes=DLLCreateRectRgn(3,24,320-6,240-24)

DLLSetWindowRgn(Window,iBothEyes,True)
;DLLPositionWindow(Window,0,0)

For Index=1 To 150
	T.Tree=New Tree
	T\X#=-180+Index*Rand(3,5)
	T\Y#=Rnd(-4,4)
	T\Z#=Rnd(1,2)
	T\S#=Rnd(0.75,1.25)/T\Z#
Next
SortTree()

For Index=1 To 1000
	S.Star=New Star
	X#=Rnd(-400,400)
	Y#=Rnd(-400,400)
	S\R#=ATan2(Y#,X#)
	S\L#=Sqr(X#*X#+Y#*Y#)
	S\S#=Rnd(0.25,1)
	If Rand(1,200)=1 Then S\S#=S\S#*Rnd(1.5,2)
	S\Sort=Rand(0,1)
Next

Local SkyX#,SkyRot#
Dim SkyR(16),SkyG(16),SkyB(16)
;Nacht 3Uhr
SkyR(1)=0
SkyG(1)=20
SkyB(1)=75
SkyR(2)=40
SkyG(2)=30
SkyB(2)=140
;Morgen
SkyR(3)=40
SkyG(3)=70
SkyB(3)=130
SkyR(4)=255
SkyG(4)=150
SkyB(4)=120
;Vormittag
SkyR(5)=105
SkyG(5)=170
SkyB(5)=255
SkyR(6)=220
SkyG(6)=240
SkyB(6)=255
;Mittag
SkyR(7)=160
SkyG(7)=220
SkyB(7)=255
SkyR(8)=200
SkyG(8)=240
SkyB(8)=255
;Nachmittag
SkyR(9)=160
SkyG(9)=190
SkyB(9)=255
SkyR(10)=150
SkyG(10)=235
SkyB(10)=235
;Abend
SkyR(11)=210
SkyG(11)=170
SkyB(11)=255
SkyR(12)=240
SkyG(12)=90
SkyB(12)=60
;SptAbend
SkyR(13)=50
SkyG(13)=60
SkyB(13)=140
SkyR(14)=115
SkyG(14)=200
SkyB(14)=215
;Nacht 0Uhr
SkyR(15)=0
SkyG(15)=15
SkyB(15)=45
SkyR(16)=0
SkyG(16)=20
SkyB(16)=80

Repeat
	Cls
	If MouseHit(1)
		DLLSystemMoveWindow(Window)
	EndIf

	If KeyHit(57) Then SpeedMode=1-SpeedMode

	zeit$=CurrentTime()
	tag=GetDate(1)
	monat=GetDate(2)
	jahr=GetDate(3)
	tage_moeglich=GetDate(4)
	schaltjahr=GetDate(5)
		
	H#=Int(Left(zeit$,2))
	Min#=Int(Mid(zeit$,4,2))
	Sec#=Int(Right(zeit$,2))

	TurnEntity Light,0,0.01,0
	If SpeedMode Then Hour#=(Hour#+0.025) Mod 24
	If Not SpeedMode Then Hour#=H#+Min#/60+Sec#/3600

	;Himmel Einstellen!
	;Morgendmmerung
	For Index=0 To 6
		If Hour#=>Index*3 And Hour#<Index*3+3 Then
			P#=(Hour#-Index*3)/3
			AmbientLight(SkyR(Index*2+2)*(1-P#)+SkyR(Index*2+4)*P#,SkyG(Index*2+2)*(1-P#)+SkyG(Index*2+4)*P#,SkyB(Index*2+2)*(1-P#)+SkyB(Index*2+4)*P#)
			ColorG3D(SkyR(Index*2+1)*(1-P#)+SkyR(Index*2+3)*P#,SkyG(Index*2+1)*(1-P#)+SkyG(Index*2+3)*P#,SkyB(Index*2+1)*(1-P#)+SkyB(Index*2+3)*P#)
			DrawImage3D(GFX_Grab(1),0,0)
			ColorG3D(SkyR(Index*2+2)*(1-P#)+SkyR(Index*2+4)*P#,SkyG(Index*2+2)*(1-P#)+SkyG(Index*2+4)*P#,SkyB(Index*2+2)*(1-P#)+SkyB(Index*2+4)*P#)
			DrawImage3D(GFX_Grab(1),0,0,0,180)
		EndIf
	Next
	If Hour#=>21 And Hour#<24 Then
		P#=(Hour#-21)/3
		AmbientLight(SkyR(16)*(1-P#)+SkyR(2)*P#,SkyG(16)*(1-P#)+SkyG(2)*P#,SkyB(16)*(1-P#)+SkyB(2)*P#)
		ColorG3D(SkyR(15)*(1-P#)+SkyR(1)*P#,SkyG(15)*(1-P#)+SkyG(1)*P#,SkyB(15)*(1-P#)+SkyB(1)*P#)
		DrawImage3D(GFX_Grab(1),0,0)
		ColorG3D(SkyR(16)*(1-P#)+SkyR(2)*P#,SkyG(16)*(1-P#)+SkyG(2)*P#,SkyB(16)*(1-P#)+SkyB(2)*P#)
		DrawImage3D(GFX_Grab(1),0,0,0,180)
	EndIf
	
	;Sternenhimmel
	SkyX#=-Sin(SkyRot#)*100
	SkyRot#=(Hour#+3)/24*360
	ColorG3D(255,255,255,Cos(SkyRot#)+0.5)
	For S.Star=Each Star
		DrawImage3D(GFX_Grab(3),SkyX#+Cos(S\R#+SkyRot#)*S\L#,Sin(S\R#+SkyRot#)*S\L#,0,S\R#,S\S#)
	Next
	;Mond
	PositionEntity Moon,Cos(SkyRot#+70)*30-1,Sin(SkyRot#+70)*25-15,25
	ColorG3D(255,255,255)
	;Sonne
	If Hour#>0 And Hour#<18 Then DrawImage3D(GFX_Grab(10),Cos(SkyRot#*1.2+240)*100-1,Sin(SkyRot#*1.2+240)*100)
	
	;Sternschnuppen
	If (Hour#=>9 And Hour#<=24) Or (Hour#>=0 And Hour#<=3) Then
		If Rand(1,700)=1 Then
			K.Komet=New Komet
			K\X#=Rnd(-250,250)
			K\Y#=Rnd(0,100)
			K\XS#=Rnd(-8,-2)
			K\YS#=Rnd(-5,-2)
			K\S#=Rnd(0.5,1)
		EndIf
	EndIf
	For K.Komet=Each Komet
		ColorG3D(255,255,255,(100-K\T#)/100)
		DrawImage3D(GFX_Grab(6),K\X#,K\Y#,0,0,K\S#)
		K\X#=K\X#+K\XS#
		K\Y#=K\Y#+K\YS#
		K\T#=K\T#+1
		If K\T#=100 Then Delete K.Komet
	Next
	
	ColorG3D(255,255,255)
	;FX
	If FXMode=0 Then
		If Hour#=>0 And Hour#<11 And Rand(1,700)=1 Then
			FXSort=1;Bergstadt
			FXX#=300
			FXMode=1
		EndIf
		If (Hour#>=0 And Hour#<=3) And Rand(1,300)=1 Then
			FXSort=2;Paris
			FXX#=300
			FXMode=1
		EndIf
		If (Hour#>=8 And Hour#<=24) And Rand(1,800)=1 Then
			FXSort=3;London
			FXX#=300
			FXMode=1
		EndIf
		If (Hour#>=6 And Hour#<=10) And Rand(1,400)=1 Then
			FXSort=4;Berlin
			FXX#=300
			FXMode=1
		EndIf
	Else
		Select FXSort
		Case 1
			FXX#=FXX#-0.085
			DrawImage3D(GFX_Grab(5),FXX#,-30)
			If FXX#<-300 Then FXMode=0
		Case 2
			FXX#=FXX#-0.09
			DrawImage3D(GFX_Grab(7),FXX#,-30)
			If FXX#<-300 Then FXMode=0
		Case 3
			FXX#=FXX#-0.078
			DrawImage3D(GFX_Grab(8),FXX#,-30)
			If FXX#<-300 Then FXMode=0
		Case 4
			FXX#=FXX#-0.1
			DrawImage3D(GFX_Grab(9),FXX#,-30)
			If FXX#<-300 Then FXMode=0
		End Select
	EndIf
	
	;Wlder
	P#=Cos(SkyRot#)+1
	ColorG3D(P#*0+(1-P#)*35,P#*0+(1-P#)*45,P#*0+(1-P#)*30)
	DrawImage3D(GFX_Grab(0),0,-90,0,180)
	For T.Tree=Each Tree
		ColorG3D(P#*0+(1-P#)*35/T\Z#,P#*0+(1-P#)*45/T\Z#,P#*0+(1-P#)*30/T\Z#)
		DrawImage3D(GFX_Grab(2),T\X#,T\Y#-60,0,0,T\S#*0.5)
		T\X#=T\X#-0.25/T\Z#
		If T\X#<-180 Then T\X#=180
	Next
	Select monat
		Case 1 month$="Januar"
		Case 2 month$="Februar"
		Case 3 month$="Mrz"
		Case 4 month$="April"
		Case 5 month$="Mai"
		Case 6 month$="Juni"
		Case 7 month$="Juli"
		Case 8 month$="August"
		Case 9 month$="September"
		Case 10 month$="Oktober"
		Case 11 month$="November"
		Case 12 month$="Dezember"
	End Select
	Text3D(Font,0,100,tag+"."+month$+" "+jahr+"  -  "+Int(Hour#)+":"+Int(Min)+":"+Int(Sec)+" Uhr",1)
	If monat=1 And tag=1 Then Text3D(Font,0,80,"Frohes neues Jahr "+jahr+"!",1)
	If monat=10 And tag=31 Then Text3D(Font,0,80,"Happy Halloween!",1)
	If monat=12 And tag=6 Then Text3D(Font,0,80,"Nikolaus",1)
	If monat=12 And tag=24 Then Text3D(Font,0,80,"Frhliche Weihnachten!",1)
	If monat=5 And tag=1 Then Text3D(Font,0,80,"Tag der Arbeit",1)
	
	;UpdateWorld
	RenderWorld
	Clear3D()
	
	;Text 200,10,MouseX()

	Flip
Until KeyDown(1)

DLLSetWindowRgn(Window,0,False) ; Remove regions
DLLDeleteObject(iBothEyes)    ; Delete GDI object
End

Type Tree
	Field X#,Y#,Z#,S#
End Type
Type Star
	Field R#,L#,S#,Sort
End Type
Type Komet
	Field X#,Y#,XS#,YS#,S#,T#
End Type
Type TypeSort
	Field THandle
End Type

Function SortTree()
	Local T1.Tree,T2.Tree,count
	For T1.Tree=Each Tree
		TS.TypeSort=New TypeSort
		TS\THandle=Handle(T1.Tree)
	Next
	For TS.TypeSort=Each TypeSort
		T2.Tree=Object.Tree(TS\THandle)
		For T1.Tree=Each Tree
			If T1\Z#>T2\Z# Then
				Insert T2.Tree After T1.Tree
			EndIf
		Next
		Delete TS.TypeSort
	Next	
End Function

Function GetDate(sort)
	Local datum_temp$,year,month,day,day_possible,special_year,special
	datum_temp$ = CurrentDate$()
	datum_temp$ = Mid$(datum_temp$,4,3)
	Select datum_temp$
		Case "Jan" datum_temp$ = 1
		Case "Feb" datum_temp$ = 2
		Case "Mar" datum_temp$ = 3
		Case "Apr" datum_temp$ = 4
		Case "May" datum_temp$ = 5
		Case "Jun" datum_temp$ = 6
		Case "Jul" datum_temp$ = 7
		Case "Aug" datum_temp$ = 8
		Case "Sep" datum_temp$ = 9
		Case "Oct" datum_temp$ = 10
		Case "Nov" datum_temp$ = 11
		Case "Dec" datum_temp$ = 12
	End Select
	day = Left$(CurrentDate$(),2)
	year = Right$(CurrentDate$(),4)
	month = Int(datum_temp$)
	special = year Mod 4
	
	Select month
		Case 1 day_possible = 31
		Case 2
			If special_year = True Then
				day_possible = 29
			Else
				day_possible = 28
			EndIf
		Case 3 day_possible = 31
		Case 4 day_possible = 30
		Case 5 day_possible = 31
		Case 6 day_possible = 30
		Case 7 day_possible = 31
		Case 8 day_possible = 31
		Case 9 day_possible = 30
		Case 10 day_possible = 31
		Case 11 day_possible = 30
		Case 12 day_possible = 31
	End Select
		
	If sort = 1 Then Return day
	If sort = 2 Then Return month
	If sort = 3 Then Return year
	If sort = 4 Then Return day_possible
	If sort = 5 Then If special = 0 Return True Else Return False
End Function