SuperStrict

Rem
*************************

	HolzUhr - BCC #29

	von Holzchopf

*************************
End Rem

' Modulols
Framework BRL.GlMax2D
Import BRL.Max2D
Import BRL.PNGLoader
Import BRL.Timer
Import BRL.RamStream

Incbin "_bin/font.png"

'===================
' Einstellungen
'===================
' Grsse der Textur
Const cTexWidth:Int		= 40
Const cTexHeight:Int	= 180

' Holzfarben
Const cTexCol1:Int	= $a85f1e
Const cTexCol2:Int	= $964214
' Schriftfareb
Const cTextR:Byte	= $99
Const cTextG:Byte	= $cc
Const cTextB:Byte	= $ff

' Feinheit der Struktur
Const cTexFibres:Int	= 40

' Radius der Rdchen
Const cCylinderRadius:Int	= 35

'===================
' Deklarationen
'===================

' Rad
Type TWheel
	Field Digit:Byte	' wievielte Stelle
	Field Char:Byte	' dargestelltes Zeichen
	Field _nChar1:Byte	' nchstes Zeichen
	Field _nChar2:Byte	' bernchstes Zeichen
	
	Field _Front:Int		' Welche Seite vorne ist
	Field _Rotation:Int		' Momentandrehung
	Field _Rotating:Byte	' Drehend
	Field _RotStartTime:Int	' Startzeit der Drehung
	Field _RotTime:Int		' Zeit fr die aktuelle Rotation
	Field _nRotTime:Int		' Zeit fr die nchste Rotation

	Field __Rot1:Int	' letzter Winkel
	Field __Rot2:Int	' vorletzter Winkel

	' Rad erstellen
	Function Create:TWheel( pDigit:Int, pChar:Byte = 46 )
		' Ascii-Wert in Frame umwandeln
		_Char( pChar )
		
		Local Wheel:TWheel = New TWheel
		
		Wheel.Digit = pDigit
		Wheel.Char = pChar
		Wheel._nChar1 = $FF
		Wheel._nChar2 = $FF
		
		Wheel.__Rot1 = -1
		Wheel.__Rot2 = -1
		
		Return Wheel
	End Function
	
	' Wert des Rades ndern
	Method Change( pChar:Byte, pSpeed:Int )
		_Char( pChar )
		
		If Self._nChar1 = $FF
			If pChar <> Self.Char
				Self._RotTime = pSpeed
				Self._nChar1 = pChar
				Self._Impulse()
			EndIf
		Else
			If pChar <> Self._nChar1
				If pChar <> Self._nChar2
					Self._nRotTime = pSpeed
					Self._nChar2 = pChar
				EndIf
			EndIf
		EndIf
	End Method
	
	' Rad zeichnen
	Method Draw()
		Self._Update()
		Self._Draw()
	End Method
	
	' ASCII-Wert in Frame umwandeln
	Function _Char:Byte( pChar:Byte Var )
		If pChar = 46		' .
			pChar = 10
		ElseIf pChar = 58	' :
			pChar = 11
		Else				' 0 -9
			pChar = pChar -48
		EndIf
	End Function
	
	' Rad in Drehung versetzen
	Method _Impulse()
		If Self._Rotating Return
		Self._RotStartTime = MSec
		Self._Rotating = True
	End Method
	
	' Aktualisieren
	Method _Update()
		' Rad ist in Bewegung
		If Self._Rotating
			' Bewegung abgeschlossen
			If MSec > (Self._RotStartTime +Self._RotTime)
				Self._Rotating = False
				Self._Front = 1 -Self._Front
				Self._Rotation = Self._Front *180
				Self.Char = Self._nChar1
				Self._nChar1 = Self._nChar2
				Self._nChar2 = $FF
				' wenn noch ein neues Zeichen ansteht
				If Self._nChar1 < $FF
					Self._RotTime = Self._nRotTime
					Self._Impulse()
				EndIf
			' Winkel erhhen
			Else
				Self._Rotation = Self._Front *180 +360 -(1 -Cos((Double(MSec -Self._RotStartTime) /Self._RotTime) *180.0)) *90.0
			EndIf
		EndIf
	End Method
	
	' Zeichnen
	Method _Draw()
		' verlassen, wenn sich das Rad seit 2 Frames nicht mehr gedreht hat
		' (verhindert Flimmern durch Doublebuffering)
		If Self._Rotation = Self.__Rot2 Return
		Self.__Rot2 = Self.__Rot1
		Self.__Rot1 = Self._Rotation
		' lalala... Magie!
		SetBlend ALPHABLEND
		For Local y:Int = 0 To cCylinderRadius *2 -1
			SetColor 255,255,255
			Local angle:Int = (Angles[y] +Self._Rotation) Mod 360
			DrawImage( Texture, 10 +Self.Digit *cTexWidth, 10 +y, (((angle +90) Mod 360) *cTexHeight /360) *8 +Self.Digit )
			If angle => 45 And angle < 135
				Local lChar:Byte
				If Self._Front = 0
					lChar = Self.Char
				Else
					lChar = Self._nChar1
				EndIf
				SetColor cTextR, cTextG, cTextB
				SetScale cTexWidth /40.0, 1
				DrawImage( Font, 10 +Self.Digit *cTexWidth, 10 +y, (angle -45) *12 +lChar )
			ElseIf angle => 225 And angle < 315
				Local lChar:Byte
				If Self._Front = 1
					lChar = Self.Char
				Else
					lChar = Self._nChar1
				EndIf
				SetColor cTextR, cTextG, cTextB
				SetScale cTexWidth /40.0, 1
				DrawImage( Font, 10 +Self.Digit *cTexWidth, 10 +y, (angle -225) *12 +lChar )
			EndIf
			SetScale 1,1
		Next
		' Blende Zeichnen (verleiht leichten Tiefeneffekt)
		SetColor 255,255,255
		SetBlend SHADEBLEND
		DrawImage( Blend, 10 +Self.Digit *cTexWidth, 10 )
	End Method
End Type

' Uhr
Type TWatch
	Field _Wheel:TWheel[8]	' Alle Rder
	Field _Mode:Byte		' Uhr / Stoppuhr
	Field _Display:Byte		' Zeit / Datum
	Field _Time:Int		' Zeit
	Field _StartTime:Int	' Startzeit beim Stoppen
	
	Field __Speeds:Int[]	' Drehgeschwindigkeiten
	
	Const MODE_WATCH:Byte	= 0
	Const MODE_CHRONO:Byte	= 1
	
	Const DISPLAY_TIME:Byte	= 0
	Const DISPLAY_DATE:Byte	= 1
	
	' Drehgeschwindigkeiten der Rder
	Global SPEEDS_CHANGE:Int[]	= [1000	, 1000	, 800	, 600	, 600	, 500	, 400	, 400]
	Global SPEEDS_TIME:Int[]		= [2000	, 2000	, 400	, 1000	, 1000	, 400	, 250	, 250]
	Global SPEEDS_DATE:Int[]		= [4000	, 4000	, 400	, 2000	, 2000	, 400	, 1000	, 1000]
	Global SPEEDS_CHRONO:Int[]	= [600	, 600	, 400	, 200	, 200	, 400	, 80 	, 50]
	
	' Uhr erstellen
	Function Create:TWatch()
		Local Watch:TWatch = New TWatch
		
		' Initizalisieren mit Zeit
		Watch._Mode	= TWatch.MODE_WATCH
		Watch._Display	= TWatch.DISPLAY_TIME
		Local Time:String = CurrentTime()
		For Local a:Int = 0 To 7
			Watch._Wheel[a] = TWheel.Create( a, Time[a] )
		Next
		Watch.__Speeds = SPEEDS_TIME
	
		Return Watch
	End Function

	' Zeit aktualisieren
	Method Update()
		' zwischen Uhr und Stoppuhr umschalten
		If MouseHit(MOUSE_RIGHT)
			If Self._Mode = MODE_WATCH
				Self._Mode = MODE_CHRONO
				Self._Time = 0
				Self._StartTime = 0
				Self.__Speeds = SPEEDS_CHANGE
			ElseIf Self._Mode = MODE_CHRONO And Self._Time = 0
				Self._Mode = MODE_WATCH
				Self._Display = DISPLAY_TIME
				Self.__Speeds = SPEEDS_CHANGE
			ElseIf Self._StartTime = 0
				Self._Time = 0
			EndIf
		EndIf
		' Uhr
		If Self._Mode = TWatch.MODE_WATCH
			' Datum / Zeit
			If MouseHit(MOUSE_LEFT)
				If Self._Display = TWatch.DISPLAY_TIME
					Self._Display = TWatch.DISPLAY_DATE
				Else
					Self._Display = TWatch.DISPLAY_TIME
				EndIf
				Self.__Speeds = SPEEDS_CHANGE
			EndIf
			' Zeit
			If Self._Display = DISPLAY_TIME
				Local Time:String = CurrentTime()
				Self._Update( Time )
				Self.__Speeds = SPEEDS_TIME
			' Datum
			Else
				Local lTime:Byte[256], lBuff:Byte[256]
				time_( lTime )
				strftime_( lBuff, 256, "%d.%m.%y", localtime_( lTime ) )
				Local Date:String = String.FromCString(lBuff)
				Self._Update( Date )
				Self.__Speeds = SPEEDS_DATE
			EndIf
		' Stoppuhr
		Else
			' Starten /stoppen
			If MouseHit(MOUSE_LEFT)
				If Self._StartTime = 0
					Self._StartTime = MSec
				Else
					Self._StartTime = 0
				EndIf
			EndIf
			' Zeitanzeige
			If Self._StartTime <> 0
				Self._Time = Self._Time +( MSec -Self._StartTime )
				Self._StartTime = MSec
			EndIf
			
			Local Hundredth:String	= "0" +((Self._Time Mod 1000) /10)
			Local Seconds:String	= "0" +((Self._Time Mod 60000) /1000)
			Local Minutes:String	= "0" +((Self._Time Mod 360000) /60000)
			Local TimeStr:String = Minutes[Len(Minutes)-2..] +":" +Seconds[Len(Seconds)-2..] +"." +Hundredth[Len(Hundredth)-2..]
			
			Self._Update( TimeStr )
			Self.__Speeds = SPEEDS_CHRONO
		EndIf
	End Method
	
	' Uhr zeichnen
	Method Draw()
		For Local a:Int = 0 To 7
			Self._Wheel[a].Draw()
		Next
	End Method
	
	' Ziffern aktualisieren
	Method _Update( pString:String )
		For Local a:Int = 0 To 7
			Self._Wheel[a].Change( pString[a], Self.__Speeds[a] )
		Next
	End Method
End Type

Global MSec:Int

Global Timer:TTimer = CreateTimer(60)

Global Angles:Int[360]

' Die obergeilgerenderte Holztextur
Global Texture:TImage = CreateWoodTex()
Global Blend:TImage = CreateBlend()

Global Font:TImage = LoadAnimImage( "incbin::_bin/font.png", 40, 1, 0, 12 *90, 0 )

Global Watch:TWatch = TWatch.Create()

'===================
' Main :>
'===================

For Local y:Int = 0 To cCylinderRadius *2 -1
	Angles[y] = ACos( Float(cCylinderRadius -y -0.5) /Float(cCylinderRadius -0.5) )
Next

AppTitle = "HolzUhr v2"
SetGraphicsDriver( GLMax2DDriver() )
Graphics(cTexWidth *8 +20, cCylinderRadius *2 +20, 0)

While Not (KeyDown(KEY_ESCAPE) Or AppTerminate())
	MSec = MilliSecs()
	
	Watch.Update()
	Watch.Draw()

	Flip 0
	WaitTimer( Timer )
Wend
End

'===================
' Funktionen
'===================

' Holztextur erstellen
Function CreateWoodTex:TImage()
	Local Image:TImage = CreateImage( cTexWidth, 1, cTexHeight *8 )
	
	Local frame:Int, y:Int,x:Int,z:Int, v:Double, col:Int
	For frame = 0 To cTexHeight *8 -1
		y = (frame /8) *360 /cTexHeight
		Local Pixmap:TPixmap = LockImage( Image, frame )
		For x = 0 To cTexWidth -1
			Local r:Int = 50 -(x=cTexWidth Or x=cTexWidth -1)
			v = fHolz(x +(frame Mod 8) *cTexWidth,Cos(y)*r,Sin(y)*r)
			col = InterpolateColors( cTexCol1, cTexCol2, v )
			WritePixel( Pixmap, x,0, $FF000000 | col )
		Next
		UnlockImage( Image, frame )
	Next
	
	Return Image
End Function

' f von Holz :>
Function fHolz:Double(x:Double, y:Double, z:Double)
	Local RefY:Double = y +(x-80)^2/6000.0 +z*Tan(x/30.0)

	Return (Sin(RefY *cTexFibres) +Sin(3 *RefY *cTexFibres)/4.0) /0.89
End Function

' Blende erstellen
Function CreateBlend:TImage()
	Local Image:TImage = CreateImage( cTexWidth, cCylinderRadius *2 )
	
	Local Pixmap:TPixmap = LockImage( Image )
	
	Local y:Int,x:Int, v:Double, alpha:Int
	For y = 0 To cCylinderRadius *2 -1
		v = ((y -cCylinderRadius ) /Double( cCylinderRadius )) ^2
		For x = 0 To cTexWidth -1
			alpha = 95 +(1-v) *160
			If x=0 Or x=cTexWidth -1 alpha:*0.9
			WritePixel( Pixmap, x,y, $FF000000 | alpha Shl 16 | alpha Shl 8 | alpha )
		Next
	Next
	UnlockImage( Image )
	
	Return Image
End Function

' Farben interpolieren
Function InterpolateColors:Int( col1:Int, col2:Int, v:Double )
	v = (v +1) /2.0
	If v < 0 Then v = 0
	If v > 1 Then v = 1
	
	Local rBase:Int = (col1 Shr 16) & $FF
	Local gBase:Int = (col1 Shr 08) & $FF
	Local bBase:Int = (col1       ) & $FF

	Local rHigh:Int = (col2 Shr 16) & $FF
	Local gHigh:Int = (col2 Shr 08) & $FF
	Local bHigh:Int = (col2       ) & $FF

	Local rEff:Int	= (rHigh -rBase) *v +rBase
	Local gEff:Int	= (gHigh -gBase) *v +gBase
	Local bEff:Int	= (bHigh -bBase) *v +bBase
	
	Return (rEff Shl 16) | (gEff Shl 08) | bEff
End Function
