
Type Mesh
	
	Global list:TList
	
	Field x:Float,y:Float,z:Float,yaw:Float
	Field surf:TList
	
	
	'Ldt ein Milkshape-Modell aus einer Datei
	Function LoadMS3D:Mesh(pfad:String)
		Local file:TStream=ReadFile(pfad:String)

		If file:TStream=Null Then
			DebugLog "Datei nicht gefunden: "+pfad:String
			Return Null
		EndIf

		Local size:Long=StreamSize(file:TStream)
		Local bank:TBank=CreateBank(size:Long)
		ReadBank(bank:TBank, file:TStream, 0, size:Long)
		CloseFile(file:TStream)
		
		'HEADER UND VERSIONSNUMMER AUSLESEN (EVTL. FEHLERMELDUNG)
		Local header:String=Chr(PeekByte(bank:TBank, 0))+Chr(PeekByte(bank:TBank,1))+Chr(PeekByte(bank:TBank,2))+Chr(PeekByte(bank:TBank,3))+Chr(PeekByte(bank:TBank,4))+Chr(PeekByte(bank:TBank,5))+Chr(PeekByte(bank:TBank,6))+Chr(PeekByte(bank:TBank,7))+Chr(PeekByte(bank:TBank,8))+Chr(PeekByte(bank:TBank,9)) 
		If header:String<>"MS3D000000" Then
			DebugLog pfad:String+" keine *.ms3d Datei angegeben"
			Return Null
		EndIf
		Local version:Int=PeekShort(bank:TBank, 10)
		If version:Int<3 Or version:Int>4 Then
			DebugLog pfad:String+" Fehlerhafte Dateiversionsnummer"
			Return Null
		EndIf
		
		
		'VERTICES AUSLESEN
		Local offset:Int=10+2*2 'An welcher Stelle in der Bank sind wir?
		Local num_vertices:Int=PeekShort(bank:TBank, offset:Int) ; offset:Int:+2
		Local VData:Vertex[num_vertices:Int]
		For Local I:Int=0 Until num_vertices:Int
			offset:Int:+1 'Keine Skeletal Animation vorhanden -> BoneID wird nicht gebraucht
			Local vx:Float=PeekFloat(bank:TBank, offset:Int) ; offset:Int:+4
			Local vy:Float=PeekFloat(bank:TBank, offset:Int) ; offset:Int:+4
			Local vz:Float=PeekFloat(bank:TBank, offset:Int) ; offset:Int:+4
			VData:Vertex[I:Int]=Vertex.Create(vx:Float/10.0, vy:Float/10.0, vz:Float/10.0)
			offset:Int:+2
		Next
		
		'TRIANGLES AUSLESEN
		Local num_triangles:Int=PeekShort(bank:TBank, offset:Int) ; offset:Int:+2
		Local TData:Triangle[num_triangles:Int]
		For Local I:Int=0 Until num_triangles:Int
			Local vex:Int[3]
			offset:Int:+2
			vex:Int[0]=PeekShort(Bank:TBank, offset:Int) ; offset:Int:+2
			vex:Int[1]=PeekShort(Bank:TBank, offset:Int) ; offset:Int:+2
			vex:Int[2]=PeekShort(Bank:TBank, offset:Int) ; offset:Int:+2
			TData:Triangle[I:Int]=Triangle.Create(VData:Vertex[vex:Int[0]], VData:Vertex[vex:Int[1]], VData:Vertex[vex:Int[2]])
			'Normalen einlesen
			TData[I:Int].vex[0].nx=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[0].ny=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[0].nz=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[1].nx=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[1].ny=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[1].nz=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[2].nx=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[2].ny=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[2].nz=PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			'offset:Int:+9*4
			
			TData[I:Int].vex[0].u=1.0-PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[1].u=1.0-PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[2].u=1.0-PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4

			TData[I:Int].vex[0].v=1.0-PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[1].v=1.0-PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			TData[I:Int].vex[2].v=1.0-PeekFloat(Bank:TBank, offset:Int) ; offset:Int:+4
			
			offset:Int:+2
		Next
		
		'SURFACES AUSLESEN
		Local num_surfaces:Int=PeekShort(bank:TBank, offset:Int) ; offset:Int:+2
		Local mesh:Mesh=New Mesh
		For Local I:Int=0 Until num_surfaces:Int
			offset:Int:+1
			Local surf:Surface=mesh.AddSurface()
			For Local A:Int=0 Until 32
				surf.name:String:+Chr(PeekByte(bank:TBank, offset:Int))
				offset:Int:+1
			Next
			Local tri_in_surf:Int=PeekShort(bank:TBank, offset:Int) ; offset:Int:+2
			For Local M:Int=0 Until tri_in_surf:Int
				ListAddLast surf.tri:TList, TData[PeekShort(bank:TBank, offset:Int)] ; offset:Int:+2
			Next
			surf.mustupdate:Byte=PeekByte(bank:TBank, offset:Int) ; offset:Int:+1
		Next
		
		'MATERIALS AUSLESEN
		Local num_materials:Int=PeekShort(bank:TBank, offset:Int) ; offset:Int:+2
		If num_materials:Int>=1 Then
			For Local I:Int=0 Until num_materials:Int
			
				offset:Int:+32
				Local color:Float[]=[PeekFloat(Bank:TBank, offset:Int), PeekFloat(Bank:TBank, offset:Int+4), PeekFloat(Bank:TBank, offset:Int+2*4), 1.0] ; offset:Int:+3*4*4
				offset:Int:+4
				offset:Int:+4+1
				
				Local tex_path:String=""
				For Local A:Int=0 Until 128
					Local char:Byte=PeekByte(Bank:TBank, offset:Int) ; offset:Int:+1
					tex_path:String=tex_path:String+Chr(char:Byte)
				Next

				tex_path:String=Left(tex_path:String, tex_path.FindLast(".png")+4)
				tex_path:String=ExtractDir(pfad:String)+Right(tex_path:String, tex_path.Length-tex_path.Find("."))
				tex_path:String=Replace(tex_path:String,".\","\")

				Local material_tex:Texture=Texture.Load(tex_path:String)
				offset:Int:+128
				
				'Schauen, welche surfaces dieses Material benutzen
				For Local surf:Surface=EachIn mesh.surf:TList
					If surf.mustupdate:Byte=I:Int Then
						surf.mustupdate:Byte=255
						surf.tex:Texture=material_tex:Texture
						For Local tri:Triangle=EachIn surf.tri:TList
							For Local H:Int=0 To 2
								tri.vex[H].Colorf(color[0],color[1],color[2])
								'tri.vex[H].Alpha(color[3])
							Next
							'tri.UpdateNormals()
						Next
					EndIf
				Next

			Next
			
			
		EndIf

		Return mesh:Mesh
	End Function
	
	
	
	Method Position(px:Float, py:Float, pz:Float)
		x:Float=px:Float
		y:Float=py:Float
		z:Float=pz:Float
	End Method
	
	Method Translate(px:Float, py:Float, pz:Float)
		x:Float:+px:Float
		y:Float:+py:Float
		z:Float:+pz:Float
	End Method
	
	Method Move(px:Float, py:Float, pz:Float)
		x:Float:+px:Float*Cos(yaw:Float)+pz:Float*Sin(yaw:Float)
		y:Float:+py:Float
		z:Float:+pz:Float*Cos(yaw:Float)+px:Float*Sin(yaw:Float)
	End Method
	
	Method Turn(ang:Float)
		yaw:Float:+ang:Float
	End Method
	
	Method Rotate(ang:Float)
		yaw:Float=ang:Float
	End Method
	
	
	Method Render()
		glPushMatrix()
			
			glTranslatef(x:Float, y:Float, -z:Float)
			glRotatef(yaw:Float, 0,1,0)
			For Local s:Surface=EachIn surf:TList
				s.Draw()
			Next
		glPopMatrix()
	End Method
	
	
	Method New()
		surf:TList=CreateList()
		ListAddLast(list:TList, Self)
	End Method
	
	Method AddSurface:Surface()
		Local s:Surface=New Surface
		ListAddLast(surf:TList, s:Surface)
		Return s:Surface
	End Method
	
	
	Method Free()
		ListRemove(list:TList, Self)
	End Method
	
	
	Method GetSurfaceByName:Surface(name:String)
		For Local s:Surface=EachIn surf:TList
			For Local A:Int=0 Until name.length
				If s.name[A]<>name[A] Then Exit
				If A=name.length-1 Then Return s:Surface
			Next
		Next
	End Method
	
End Type














Type Surface
	
	Field tri:TList
	Field vbo:Int[4]	'4 VertexBufferObjects (Geometrie, Farbe, Textur, Normalen)
	Field mustupdate:Byte, vcount:Int
	Field tex:Texture
	Field hidden:Byte, scheinen:Byte
	Field name:String
	
	Method Update()
		If mustupdate:Byte=False Then Return
	
		If vbo:Int[0]=0 Then
			glGenBuffersARB(4,vbo:Int)
		EndIf
		
		vcount:Int=CountList(tri:TList)*3
		Local Vdata:Float[vcount:Int*3], Tdata:Float[vcount:Int*2], Cdata:Float[vcount:Int*4], Ndata:Float[vcount:Int*3]
		Local A:Int=0
		For Local tri:Triangle=EachIn tri:TList
			For Local I:Byte=0 To 2
				Vdata:Float[A:Int*3]=tri.vex[I:Byte].x:Float
				Vdata:Float[A:Int*3+1]=tri.vex[I:Byte].y:Float
				Vdata:Float[A:Int*3+2]=tri.vex[I:Byte].z:Float
				
				Ndata:Float[A:Int*3]=tri.vex[I:Byte].nx:Float
				Ndata:Float[A:Int*3+1]=tri.vex[I:Byte].ny:Float
				Ndata:Float[A:Int*3+2]=-tri.vex[I:Byte].nz:Float

				Tdata:Float[A:Int*2]=tri.vex[I:Byte].u:Float
				Tdata:Float[A:Int*2+1]=tri.vex[I:Byte].v:Float
				
				Cdata:Float[A:Int*4]=tri.vex[I:Byte].rgb:Byte[0]/255.0/2.0
				Cdata:Float[A:Int*4+1]=tri.vex[I:Byte].rgb:Byte[1]/255.0/2.0
				Cdata:Float[A:Int*4+2]=tri.vex[I:Byte].rgb:Byte[2]/255.0/2.0
				Cdata:Float[A:Int*4+3]=tri.vex[I:Byte].a:Float
				A:Int:+1
			Next
		Next
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB,vbo[0])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB,(vcount:Int*3*4),Vdata,GL_DYNAMIC_DRAW_ARB)
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB,vbo[1])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB,(vcount:Int*4*4),Cdata,GL_DYNAMIC_DRAW_ARB)
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB,vbo[2])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB,(vcount:Int*2*4),Tdata,GL_DYNAMIC_DRAW_ARB)
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB,vbo[3])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB,(vcount:Int*3*4),Ndata,GL_DYNAMIC_DRAW_ARB)
		
		mustupdate:Byte=False
		
	End Method
	
	
	Method Draw()
		If hidden:Byte Then Return
		If mustupdate:Byte=True Or vbo:Int[0]=0 Then Update()
		
		If scheinen:Byte=True Then glDisable(GL_LIGHTING)
		
		glEnableClientState(GL_VERTEX_ARRAY)
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, vbo[0])	'Vertexdaten
		glVertexPointer(3, GL_FLOAT, 0, Null)
		
		glEnableClientState(GL_NORMAL_ARRAY)
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, vbo[3])	'Normalen
		glNormalPointer(GL_FLOAT, 0, Null)
		
		glEnableClientState(GL_COLOR_ARRAY)
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, vbo[1])	'Farbdaten
		glColorPointer(4, GL_FLOAT, 0, Null)
		
		If tex:Texture<>Null Then
			'glClientActiveTexture(GL_TEXTURE0)
			'glActiveTexture(GL_TEXTURE0)
			glEnableClientState(GL_TEXTURE_COORD_ARRAY)
	
			glEnable(GL_TEXTURE_2D)
			glBindTexture(GL_TEXTURE_2D,tex.gltex:Int) 
			glBindBufferARB(GL_ARRAY_BUFFER_ARB, vbo[2])	'Texturdaten Set1
			glTexCoordPointer(2, GL_FLOAT, 0, Null)
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE)
		'Else
			'glDisable(GL_TEXTURE_2D)
		EndIf
		
		Rem
		If [WIREFRAME AN] Then
			glPolygonMode(GL_FRONT,GL_LINE)
		Else
			glPolygonMode(GL_FRONT,GL_FILL)
		EndIf
		EndRem
		'glPolygonMode(GL_FRONT,GL_LINE)
		glDrawArrays(GL_TRIANGLES, 0, vcount:Int)
		
		'glClientActiveTexture(GL_TEXTURE0)
		glDisableClientState(GL_TEXTURE_COORD_ARRAY)
		
		glDisableClientState(GL_VERTEX_ARRAY)
		glDisableClientState(GL_COLOR_ARRAY)
		glDisableClientState(GL_NORMAL_ARRAY)
		
		If scheinen:Byte=True Then glEnable(GL_LIGHTING)
		
	End Method


	
	Method AddTriangle(v0:Vertex, v1:Vertex, v2:Vertex)
		ListAddLast(tri:TList, Triangle.Create(v0:Vertex, v1:Vertex, v2:Vertex))
	End Method
	
	Method SetTexture(t:Texture)
		tex:Texture=t:Texture
	End Method
	
	Method New()
		tri:TList=CreateList()
		mustupdate:Byte=True
	End Method
	
	Method Delete()
		ClearList tri:TList
		glDeleteBuffersARB(3,vbo:Int)
	End Method
	
	Method Hide()
		hidden:Byte=True
	End Method
	
	Method Show()
		hidden:Byte=False
	End Method
	
	Method Shine(leuchten:Byte=True)
		scheinen:Byte=True
	End Method
	
	
	Method Paint(r:Byte, g:Byte, b:Byte, maxdelta:Byte=0)
		For Local t:Triangle=EachIn tri:TList
			Local delta:Int=Rand(-maxdelta, maxdelta)
			t.vex[0].Color(r:Byte+delta:Int, g:Byte+delta:Int, b:Byte+delta:Int)
			t.vex[1].Color(r:Byte+delta:Int, g:Byte+delta:Int, b:Byte+delta:Int)
			t.vex[2].Color(r:Byte+delta:Int, g:Byte+delta:Int, b:Byte+delta:Int)
		Next
		mustupdate:Byte=True
	End Method
	
	Method ColorHerbstblatt()
		For Local t:Triangle=EachIn tri:TList
			Local dr:Byte=Rand(0,2)*127, dg:Byte=Rand(0,1)*255
			If dr:Byte=0 And dg:Byte=0 Then dg:Byte=255
			t.vex[0].Color(dr:Byte, dg:Byte, 0)
			t.vex[1].Color(dr:Byte, dg:Byte, 0)
			t.vex[2].Color(dr:Byte, dg:Byte, 0)
		Next
		mustupdate:Byte=True
	End Method
	
	
	
	Method RandomColor(r:Byte, g:Byte, b:Byte, dx:Byte=0, dy:Byte=0, dz:Byte=0)
		For Local t:Triangle=EachIn tri:TList
			Local dr:Byte=r:Byte+Rand(-dx, dx), dg:Byte=r:Byte+Rand(-dy, dy), db:Byte=b:Byte+Rand(-dz, dz)
			t.vex[0].Color(dr:Byte, dg:Byte, db:Byte)
			t.vex[1].Color(dr:Byte, dg:Byte, db:Byte)
			t.vex[2].Color(dr:Byte, dg:Byte, db:Byte)
		Next
		mustupdate:Byte=True
	End Method
	
	
End Type















Type Triangle
	
	Field vex:Vertex[3]
	
	Function Create:Triangle(v0:Vertex, v1:Vertex, v2:Vertex)
		Local t:Triangle=New Triangle
		t.vex[0]=v0
		t.vex[1]=v1
		t.vex[2]=v2
		Return t:Triangle
	End Function
	
	Rem 'Funktioniert nicht...
	Method UpdateNormals()
		vex[0].nx:Float=-((vex[1].y-vex[0].y)*(vex[2].z-vex[0].z)-(vex[1].z-vex[0].z)*(vex[2].y-vex[0].y))
		vex[0].ny:Float=-((vex[1].z-vex[0].z)*(vex[2].x-vex[0].x)-(vex[1].x-vex[0].x)*(vex[2].z-vex[0].z))
		vex[0].nz:Float=-((vex[1].x-vex[0].x)*(vex[2].y-vex[0].y)-(vex[1].y-vex[0].y)*(vex[2].x-vex[0].x))
		vex[1].nx:Float=vex[0].nx:Float
		vex[1].ny:Float=vex[0].ny:Float
		vex[1].nz:Float=vex[0].nz:Float
		vex[2].nx:Float=vex[0].nx:Float
		vex[2].ny:Float=vex[0].ny:Float
		vex[2].nz:Float=vex[0].nz:Float	
	End Method
	EndRem
	
End Type

















Type Vertex
	Field x:Float, y:Float, z:Float
	Field rgb:Byte[3], a:Float
	Field u:Float, v:Float
	Field nx:Float, ny:Float, nz:Float
	
	Function Create:Vertex(x:Float, y:Float, z:Float)
		Local v:Vertex=New Vertex
		v.x:Float=x:Float
		v.y:Float=y:Float
		v.z:Float=z:Float
		Return v:Vertex
	End Function
	
	Method New()
		a:Float=1.0
		rgb:Byte[0]=255
		rgb:Byte[1]=255
		rgb:Byte[2]=255
		ny:Float=1.0
	End Method
	
	
	Method TexCoords(tu:Float, tv:Float)
		u:Float=tu:Float
		v:Float=tv:Float
	End Method
	
	Method Color(r:Byte, g:Byte, b:Byte)
		rgb[0]=r
		rgb[1]=g
		rgb[2]=b
	End Method
	
	Method Colorf(r:Float, g:Float, b:Float)
		rgb[0]=r*255.0
		rgb[1]=g*255.0
		rgb[2]=b*255.0
	End Method
	
	Method Alpha(alpha:Float)
		a:Float=alpha:Float
	End Method
End Type















Type Texture

	Field gltex:Int

	Function Load:Texture(pfad:String, modus:Byte=(1|2|4))
		Local tex:Texture=New Texture
		Local pix:TPixmap=LoadPixmap(pfad:String)
		If pix:TPixmap=Null Then
			DebugLog "Textur nicht gefunden: "+pfad:String
			Return Null
		EndIf
		Local xs:Int=pix.width, ys:Int=pix.height
		GLAdjustTexSize(xs:Int, ys:Int)
		pix:TPixmap=ResizePixmap(ConvertPixmap(pix:TPixmap,PF_RGBA8888), xs:Int, ys:Int)
		Local zeiger:Byte Ptr=PixmapPixelPtr(pix:TPixmap)
		Local pp:Int=0
		Local glimg:Byte[pix.Width, pix.Height, 4]
		
		For Local u:Int=pix.Width-1 To 0 Step -1
			For Local v:Int=0 To pix.Height-1
				glimg[u:Int,v:Int,0]=zeiger[pp:Int]
				glimg[u:Int,v:Int,1]=zeiger[pp:Int+1]
				glimg[u:Int,v:Int,2]=zeiger[pp:Int+2]
				glimg[u:Int,v:Int,3]=zeiger[pp:Int+3]
				If (modus:Byte & 1) And glimg[u:Int,v:Int,0]+glimg[u:Int,v:Int,1]+glimg[u:Int,v:Int,2]<=0 Then
					glimg[u:Int,v:Int,3]=0
				ElseIf (modus:Byte & 2)
					glimg[u:Int,v:Int,3]=(zeiger[pp:Int]+zeiger[pp:Int+1]+zeiger[pp:Int+2]+zeiger[pp:Int+3])/4.0
				EndIf
				pp:Int:+4
			Next
		Next
		glGenTextures(1, Varptr tex.gltex:Int)
		glBindTexture(GL_TEXTURE_2D, tex.gltex:Int)
		If (modus:Byte & 4) Then
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NICEST)
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NICEST)
		Else
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
		EndIf
		glTexImage2D(GL_TEXTURE_2D, 0, 4, pix.Width, pix.Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, glimg:Byte)
		
		Return tex:Texture
	End Function

	
	
	
End Type







Global window_size:Int=400
Global window_pos_x:Int=0
Global window_pos_y:Int=0

Function LoadOptions(pfad:String)
	Local file:TStream=ReadFile(pfad:String)
	If file:TStream=Null Then Return
	window_size:Int=Int(ReadLine(file:TStream))
	window_pos_x:Int=Int(ReadLine(file:TStream))
	window_pos_y:Int=Int(ReadLine(file:TStream))
End Function














'Erstellt Fenster und ldt Einstellungen
Function Graphics3D()

	Mesh.list:TList=CreateList()

	'OpenGL-Fenster Erstellen
	SetGraphicsDriver(GLMax2DDriver())
	Graphics(window_size:Int, window_size:Int)
	
	'Extensions laden
	glewInit()
	

	glPushAttrib(GL_ALL_ATTRIB_BITS)
	glPushClientAttrib(GL_CLIENT_ALL_ATTRIB_BITS)
	glMatrixMode(GL_MODELVIEW)
	glPushMatrix()
	glMatrixMode(GL_PROJECTION)
	glPushMatrix()
	glMatrixMode(GL_TEXTURE)
	glPushMatrix()
	glMatrixMode(GL_COLOR)
	glPushMatrix()
	
	
	glEnable(GL_CULL_FACE)		'Backface Culling aktivieren
	glPolygonMode(GL_FRONT,GL_FILL)
	glClearColor(0,0,0,0)   	'Hintergrundfarbe schwarz
	glShadeModel(GL_SMOOTH)	'Smoothshading aktivieren
	glEnable(GL_ALPHA_TEST)	'Unsichtbare Fragmente nicht zeichnen
	glAlphaFunc(GL_GREATER, 0.01)
	
	glEnable(GL_POINT_SMOOTH)	'Punkte sollen auch rund sein
	
	'OpenGL-Licht aktivieren
	glEnable(GL_LIGHTING)
	glEnable(GL_LIGHT0)
	light_amb:Float=[0.5,0.5,0.5,1.0]
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_amb:Float)
	
	'fr Z-Buffering
	glClearDepth(1.0)
	glEnable(GL_DEPTH_TEST)
	glDepthFunc(GL_LEQUAL)
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	glColorMask(1,1,1,1)
	
	'Alphablending aktivieren
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	
	'Vertexfarben auch bercksichtigen
	glColorMaterial(GL_FRONT, GL_EMISSION)
	glMaterialf(GL_FRONT, GL_SHININESS, 100.0)
	glEnable(GL_COLOR_MATERIAL)
	
	glEnable(GL_NORMALIZE)

	
	'Matrix-Einstellungen laden
	glMatrixMode(GL_PROJECTION)
	glPushMatrix()
	glLoadIdentity()
	gluPerspective(45.0, 1, 1, 100.0)
	glMatrixMode(GL_TEXTURE)
	glPushMatrix()
	glMatrixMode(GL_COLOR)
	glPushMatrix()
	glMatrixMode(GL_MODELVIEW)
	glPushMatrix()
	glLoadIdentity()
	
	
End Function



'Stellt Hintergrundfarbe ein
Function ClearColor(r:Byte, g:Byte, b:Byte)
	glClearColor(r:Byte/255.0, g:Byte/255.0, b:Byte/255.0, 0)
End Function



Global camera_distance:Float=50
Global camera_rotation:Float=30

Function SetCameraDistance(dist:Float=50)
	camera_distance:Float=dist:Float
End Function

Function SetCameraAngle(ang:Float=10)
	camera_rotation:Float=ang:Float
End Function


Global light_amb:Float[4], light_pos:Float[4], light_rgb:Float[4], light_ang:Float[4]
Function SetAmbientLight(r:Float, g:Float, b:Float)
	light_amb:Float=[r:Float,g:Float,b:Float,0.0]
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_amb:Float)
End Function

Function SetLightPosition(x:Float, y:Float, z:Float)
	light_pos:Float=[x:Float,y:Float,-z:Float,1.0]
	light_ang:Float=[-x:Float,-y:Float,z:Float,1.0]
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos:Float)
End Function

Function SetLightColor(r:Float, g:Float, b:Float)
	light_rgb:Float=[r:Float/2.0,g:Float/2.0,b:Float/2.0,1.0]
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_rgb:Float)
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_rgb:Float)
	'glLightfv(GL_LIGHT0, GL_EMISSION, light_rgb:Float)
End Function










'Rendert alles
Function RenderAll(clear:Byte=True)
	If clear:Byte Then glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	glFlush()
	
	'Modus3D()
	

	'glPushAttrib(GL_ALL_ATTRIB_BITS)
	'glPushClientAttrib(GL_CLIENT_ALL_ATTRIB_BITS)
	

	
	'glEnable(GL_SCISSOR_TEST)
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	gluPerspective(45.0, 1, camera_distance:Float/50.0, camera_distance:Float*2.0)
	
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()

	glLightfv(GL_LIGHT0, GL_AMBIENT, light_amb:Float)
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos:Float)
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_rgb:Float)
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_rgb:Float)
	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, light_ang:Float)
	'glLightfv(GL_LIGHT0, GL_EMISSION, light_rgb:Float)

	glTranslatef(0,0,-camera_distance:Float)
	glRotatef(camera_rotation:Float,1,0,0)
	

	
	glPushMatrix()
	For Local m:Mesh=EachIn Mesh.list:TList
		m.Render()
	Next
	glPopMatrix()
	'glDisable(GL_SCISSOR_TEST)
	
	'glPopAttrib()
	'glPopClientAttrib()
	
	'Modus2D()

End Function








Function Modus3D()
	glEnable(GL_CULL_FACE)
	glMatrixMode(GL_MODELVIEW)
	glPopMatrix()
	glMatrixMode(GL_PROJECTION)
	glPopMatrix()
End Function



Function Modus2D()
	glMatrixMode(GL_MODELVIEW)
	glPushMatrix()
	glLoadIdentity()
	glMatrixMode(GL_PROJECTION)
	glPushMatrix()
	glLoadIdentity()
	glOrtho(0,window_size:Int,window_size:Int,0,-1,1)
	glDisable(GL_CULL_FACE)
End Function






Global weather_list:TList=CreateList()
Function UpdateWeather()
	'Im 5-Minutentakt gibt es Niederschlge
	If (Int(CurrentTime()[3..5]) Mod 10)>5 And FramesPerSecond()>=59 And Rand(5)=1 Then
		Local dist:Float=Rnd(5.0), ang:Float=Rnd(360)
		ListAddLast(weather_list:TList, Vertex.Create(dist*Sin(ang), 10, dist*Cos(ang)))'Rand(-15,15), 10, Rand(-15,15)) )
	EndIf
	
	Local schnee:Byte=False
	glPointSize(2)
	Select GetSeason()
		Case "Sommer"
			glColor3f(0.0,0.0,1.0)	'Blaue Regentropfen
		Case "Winter"
			glColor3f(1.0,1.0,1.0)	'Weie Schneeflocken
			schnee:Byte=True
		Case "Frhling", "Herbst"
			If (Int(CurrentTime()[3..5]) Mod 20)>10 Then
				glColor3f(1.0,1.0,1.0)	'Weie Schneeflocken
				schnee:Byte=True
			Else
				glColor3f(0.6,0.6,1.0)	'Kalter Regen
			EndIf
	End Select
	glBegin(GL_POINTS)
		For Local v:Vertex=EachIn weather_list:TList
			v.y:Float:-0.2-0.1*(schnee=False)
			'v.x:Float:+Sin(MilliSecs()/100.0)/(20.0+20*(schnee=False))
			'v.z:Float:+Cos(MilliSecs()/150.0)/(20.0+20*(schnee=False))
			glVertex3f(v.x:Float, v.y:Float, v.z:Float)
			If v.y:Float<0.1 Then'-150 Then
				ListRemove(weather_list:TList, v:Vertex)
			EndIf
		Next
	glEnd()
	
	
End Function








Rem
?Win32
Extern
	Function _initWndClass()
	Function _initPfd(pfd:PIXELFORMATDESCRIPTOR, flags:Int)
Rem
	Function bbGLGraphicsGraphicsModes( buf:Byte Ptr,size )
	Function bbGLGraphicsAttachGraphics( widget,flags )
	EndRem
	'Function MyGLGraphicsCreateGraphics:Byte Ptr( width:Int,height:Int,depth:Int,hertz:Int,flags:Int )
	Rem
	Function bbGLGraphicsGetSettings( context:Int,width:Int Var,height:Int Var,depth:Int Var,hertz:Int Var,flags:Int Var )
	Function bbGLGraphicsClose( contex:intt )	
	Function bbGLGraphicsSetGraphics( context:Int )
	Function bbGLGraphicsFlip( sync:Int )
	End  Rem
End Extern
?



'Um die Titelleiste oben wegzubekommen:
Type MyGfxDriver Extends TGLMax2DDriver
	Method CreateGraphics:TMax2DGraphics( width:Int,height:Int,depth:Int=0,hertz:Int=0,flags:Int=0 )
		Local mode:Int, hdc:Int, hwnd:Int, hglrc:Int
		Local pf:Long
		Local pfd:PIXELFORMATDESCRIPTOR
		Local hwnd_style:Int
		Local rect:Int[]=[0,0,width,height]
	
		_initWndClass()
	
		If depth:Int Then
			mode=3;
			hwnd_style=WS_POPUP;
		Else
			Local desktop:Int=GetDesktopWindow()
			Local desktopRect:Int[4]
			GetWindowRect(desktop:Int, desktopRect:Int)
			
			rect:Int[0]=desktopRect[0]/2-width:Int/2
			rect:Int[1]=desktopRect[2]/2-height:Int/2
			rect:Int[2]=desktopRect[0]/2+width:Int/2
			rect:Int[3]=desktopRect[2]/2+height:Int/2
			
			mode:Int=2
			hwnd_style:Int=WS_VISIBLE|WS_POPUPWINDOW
		EndIf
		
		AdjustWindowRectEx(rect:Int,hwnd_style:Int,0,0)
		Local name:String="BlitzMax GLGraphics", zeiger:Byte Ptr=Varptr(name)
		'hwnd:Int=CreateWindowExA(0,Varptr(name),Varptr(AppTitle),hwnd_style,rect[0],rect[1],rect[2]-rect[0],rect[3]-rect[1],0,0,GetModuleHandleA(0), zeiger)
		zeiger=CreateWindowExW(0,name,AppTitle,hwnd_style,rect[0],rect[1],rect[2]-rect[0],rect[3]-rect[1],0,0,GetModuleHandleA(0), 0)
		If hwnd=False Then Return 0

		GetClientRect(hwnd:Int, rect:Int)
		width:Int=rect[0]-rect[2]
		height:Int=rect[3]-rect[1]
		
		_initPfd(Varptr(pfd), flags:Int)

		hdc:Int=GetDC(hwnd:Int)
		pf:Long=ChoosePixelFormat(hdc:Int, Varptr(pfd))
		If pf=False Then
			DestroyWindow(hwnd:Int)
			Return 0
		EndIf
		SetPixelFormat(hdc:Int, pf:Int, Varptr(pfd))
		hglrc:Int=wglCreateContext(hdc:Int)
	Rem
		'If( _sharedContext ) wglShareLists( _sharedContext->hglrc,hglrc );
		Local context:TBank=CreateBank(10)
		context.PeekByte(0,SizeOf(context))
		context.PeekInt(
	context=(BBGLContext*)malloc( SizeOf(BBGLContext) );
	memset( context,0,SizeOf(context) );
	
	context->mode=mode;
	context->width=width;
	context->height=height;
	context->depth=depth;
	context->hertz=hertz;
	context->flags=flags;
	
	context->hdc=hdc;
	context->hwnd=hwnd;
	context->hglrc=hglrc;
	
	context->succ=_contexts;
	_contexts=context;
	EndR em
		ShowWindow(hwnd:Int,SW_SHOW)
	
	Return Null'context;
	End Method
End Type




EndRem





























