
Function getSecondTime:Int()
	Local hours:Int, minutes:Int, seconds:Int
	Local time:String=CurrentTime()
	hours:Int=Int(time:String[0..2])
	minutes:Int=Int(time:String[3..5])
	seconds:Int=Int(time:String[6..8])
	Return (hours:Int*60+minutes:Int)*60+seconds:Int
End Function

Function getHourTime:Float()
	Local hours:Int, minutes:Int, seconds:Int
	Local time:String=CurrentTime()
	Return (Float(time:String[0..2])+Float(time:String[3..5])/60.0+Float(time:String[6..8])/3600.0)
End Function

Function getSeason:String()
	Select CurrentDate()[3..6]
		Case "Dec", "Jan", "Feb"
			Return "Winter"
		Case "Mar", "Apr", "May"
			Return "Frhling"
		Case "Jun", "Jul", "Aug"
			Return "Sommer"
		Default
			Return "Herbst"
	End Select
End Function

Function Datum:String()
	Local zeit:String=CurrentDate()
	zeit:String=zeit.Replace(" Jan", ". Januar");		zeit:String=zeit.Replace(" Feb", ". Februar")
	zeit:String=zeit.Replace(" Mar", ". Mrz");		zeit:String=zeit.Replace(" Apr", ". April")
	zeit:String=zeit.Replace(" May", ". Mai");			zeit:String=zeit.Replace(" Jun", ". Juni")
	zeit:String=zeit.Replace(" Jul", ". Juli");		zeit:String=zeit.Replace(" Aug", ". August")
	zeit:String=zeit.Replace(" Sep", ". September");	zeit:String=zeit.Replace(" Oct", ". Oktober")
	zeit:String=zeit.Replace(" Nov", ". November");	zeit:String=zeit.Replace(" Dec", ". Dezember")
	Return zeit:String
End Function


'Zhlt die Frames per Second
Global pr_fps1:Int, pr_fps2:Int, pr_fpsecs:Int
Function FramesPerSecond:Int()
  pr_fps1:Int:+1
  If pr_fpsecs:Int+1000<MilliSecs() Then
    pr_fpsecs:Int=MilliSecs()
    pr_fps2:Int=pr_fps1:Int
    pr_fps1:Int=0
  EndIf
  Return pr_fps2:Int
End Function



Function PaintWorld()
	Select GetSeason()
		Case "Sommer"
			test.GetSurfaceByName("Fluss").Paint(10,10,245,10)
			test.GetSurfaceByName("Boden").Paint(25,225,25,25)
			test.GetSurfaceByName("Baumstmme").Paint(100, 65, 5, 5)
			test.GetSurfaceByName("Bltter").Paint(0,250,0)'.RandomColor(0,200,0, 0,20)
			test.GetSurfaceByName("Felsbrocken").Paint(100,100,100,50)
		Case "Winter"
			test.GetSurfaceByName("Fluss").Paint(220,220,245,5)
			test.GetSurfaceByName("Boden").Paint(250,250,250,5)
			test.GetSurfaceByName("Baumstmme").Paint(185,120,15, 5)
			test.GetSurfaceByName("Bltter").Hide()	'Im Winter haben Bume keine Bltter
			test.GetSurfaceByName("Felsbrocken").Paint(120,120,120,50)
		Case "Frhling"
			test.GetSurfaceByName("Fluss").Paint(10,10,245,10)
			test.GetSurfaceByName("Boden").Paint(170,225,105,25)
			test.GetSurfaceByName("Baumstmme").Paint(185,120,15, 5)
			test.GetSurfaceByName("Bltter").Paint(10,200,10)
			test.GetSurfaceByName("Felsbrocken").Paint(100,100,100,50)
		Case "Herbst"
			test.GetSurfaceByName("Fluss").Paint(10,10,245,10)
			test.GetSurfaceByName("Boden").ColorHerbstblatt()
			test.GetSurfaceByName("Baumstmme").Paint(185,120,15, 5)
			test.GetSurfaceByName("Bltter").ColorHerbstblatt()
			test.GetSurfaceByName("Felsbrocken").Paint(100,100,100,50)
	End Select
End Function


Global sunx:Float, suny:Float
Function UpdateSun()
	Local sonnenstand:Float=getHourTime()*15.0+180.0
	sunx:Float=Sin(sonnenstand:Float)*12.0
	suny:Float=Cos(sonnenstand:Float)*12.0
	SetLightPosition(sunx:Float, suny:Float, 0)
	SetAmbientLight(Cos(sonnenstand:Float), Cos(sonnenstand:Float)/1.5, Cos(sonnenstand:Float)/2.0)
	SetLightColor((1+Cos(sonnenstand:Float))/2.0, (1+Cos(sonnenstand:Float))/2.0, (1+Cos(sonnenstand:Float))/2.0)
End Function


Rem
Function GetDayInt:Int()
	'30. Januar bedeutet T = 30 (Bruchteile von Tagen zu bercksichtigen bringt nichts) 
	'(fr den 1. Februar wre T = 32) 
	Return 30
End Function


Sonnenaufgang()
Function Sonnenaufgang()
	Local tag:Int=GetDayInt()
	Local ort:Float=52.5'48.4		'Grad Nord-0.0145*180.0/Pi (Sin(50.0/60.0*tag*180.0/Pi)
	Local zenit:Float=0.4095*Sin(0.96864247756602506*(tag:Int-80.086))*180.0/Pi
	Local deltaT:Float=12.0/(ACos( (Sin(-0.0145*180.0/Pi)-Sin(ort:Float)*Sin(zenit:Float))/(Cos(ort:Float)*Cos(zenit:Float)) )*Pi/180.0 )/Pi
	Print deltaT
	Local zeit:Float=(12.0-deltaT:Float)
	Print zeit
End Function

Rem
Es soll der Sonnenaufgang fr Berlin am 30. Januar bestimmt werden. 

Berlin liegt auf  13.5 Grad Ost, 52.5 Grad Nord 


B = Pi *52.5 / 180 = 0.9163 

Deklination der Sonne: 
0.4095*Sin(0.016906*(30-80.086))  = -0.30677 = -17.58 Grad 

Sonnenaufgang h=-50 Bogenminuten = -0.0145 

Zeitdifferenz 
= 12*ArcCos((Sin(-0.0145) - Sin(0.9163)*Sin(-0.30677)) / (Cos(0.9163)*Cos(-0.30677)))/Pi 
= 4.479 Stunden. 

Sonnenaufgang um 12 - 4.477 = 7.523 Uhr Wahre Ortszeit. 

Zeitgleichung : 
-0.171*Sin(0.0337*30 + 0.465) - 0.1299*Sin(0.01787*30 - 0.168) 
= -0.217 Stunden = WOZ - MOZ 

MOZ = WOZ + 0.217 Stunden = 7.740 
= 7.840 Uhr in MEZ fr Berlin weil 7.840 = 7.740 + (15 - 13.5)*4/60 
Die MOZ des 15. stlichen Lngengrades ist die Mitteleuropische Zeit MEZ. 

Also, Sonnenaufgang fr Berlin um 7 Uhr 50! 

Ein Vergleich mit CalSky.com ergibt 7 Uhr 52 fr den Sonnenaufgang. 
Das ist OK, mit so einfachen Formeln kann man keine bessere Genauigkeit erwarten. 

EndRem



























