AppTitle "Timer"

Include "time.lib.bb"

Include "string_man.lib.bb"

Include "bass.bb"
Include "bass_wma.bb"

Global digifont, win

Const winw= 150
Const winh= 100

digifont= LoadFont (".\Digital Readout Thick Upright.ttf",40,1,0,0)


win= CreateWindow ("Timer - Uhr",50,50,winw,winh,0,47)
SetMinWindowSize win,winw,winh+50
CenterWindow (win)

;[Block] Mens
Global winmenu, datmenu, helpmenu
Global endmenu, timemenu

winmenu= WindowMenu (win)

datmenu= CreateMenu ("Datei",1,winmenu)
helpmenu= CreateMenu ("Hilfe",11,datmenu)
CreateMenu ("",0,datmenu)
endmenu= CreateMenu ("Beenden",12,datmenu)
timemenu= CreateMenu ("Timer",2,winmenu)

Global settimermenu, starttimermenu, endtimermenu
Global setmsgmenu, setsoundmenu
settimermenu= CreateMenu ("Zeit setzen",21,timemenu)
setmsgmenu= CreateMenu ("Nachricht setzen",22,timemenu)
setsoundmenu= CreateMenu ("Sound setzen",23,timemenu)
CreateMenu ("",0,timemenu)
starttimermenu= CreateMenu ("Timer starten",24,timemenu)
CreateMenu ("",0,timemenu)
endtimermenu= CreateMenu ("Timer beenden",25,timemenu)

UpdateWindowMenu win
;[End]

Global can

can= CreateCanvas (0,0,winw,winh,win)
SetBuffer CanvasBuffer (can)
SetGadgetLayout can,1,1,1,1

SetFont digifont


Global started, stime, time, ltime
Global timermsg$, timertxt$
Global sound, channel

BASS_Init (1,44100,0,0,0)

Repeat
	Select WaitEvent(50)
		Case $803
			End
		Case $1001
			Select EventData ()
				Case 21
					Set_time
				Case 22
					Set_msg
				Case 23
					Set_sound
				Case 24
					started= 1-started
					If started= 1 Then ltime= MilliSecs()
				Case 25
					started=0
					stime=0:time=0
					BASS_StreamFree (sound)
			End Select
	End Select
	
	time= Abs (stime- (MilliSecs()-ltime)/1000)
	
	Cls
	
	Color 0,128,0
	Text winw/2,25,CurrentTime$(),1,1
	
	If started Then
		Color 128,128,0
		timertxt$= Time_ssTohms$(time)
		Text winw/2,75,timertxt$,1,1
		SetStatusText (win,timertxt$)
		SetGadgetText win,"Timer: "+timertxt$
		If time=0 Then
			started= 0
			channel= BASS_ChannelPlay (sound,1)
			Notify timermsg$
			BASS_ChannelStop (channel)
			BASS_StreamFree (sound)
		EndIf
	Else
		Color 80,80,0
		timertxt$= Time_ssTohms$(stime)
		Text winw/2,75,timertxt$,1,1
	EndIf
	FlipCanvas can
	
	If started Then
		SetMenuText starttimermenu,"Timer pausieren"
	Else
		SetMenuText starttimermenu,"Timer starten"
	EndIf
	UpdateWindowMenu win
Forever

Function Set_msg ()
	timermsg$= eps_InputBox ("Timernachricht eingeben","Nachricht setzen","")
End Function

Function Set_time ()
	Local timestr$
	timestr$= eps_InputBox$ ("Zeit im Format hh:mm:ss eingeben!","Zeit setzen","00:00:00")
	stime= Time_hmsToss (timestr$)
	time= stime
End Function

Function Set_sound ()
	Stop
	Local soundfile$, filter$
	
	filter$= "Musikdateien(*.wav *.wma *.mp3 *.ogg)|*.wav;*.wma;*.mp3;*.ogg"
	soundfile$= eps_FileDialog$ (1,filter$,1,"","","Timersound setzen",0)
	If strman_filter_fileext$(soundfile$)="wma" Then
		sound= BASS_WMA_StreamCreateFile (0,soundfile$,0,0,0)
	Else
		sound= BASS_StreamCreateFile (0,soundfile$,0,0,0)
	EndIf
End Function

Function CenterWindow (fwinhndl)
	fwinw= ClientWidth (fwinhndl)
	fwinh= ClientHeight (fwinhndl)
	fdesk= Desktop()
	fdeskw= ClientWidth(fdesk)
	fdeskh= ClientHeight(fdesk)
	SetGadgetShape fwinhndl,(fdeskw-fwinw)/2,(fdeskh-fwinh)/2,fwinw,fwinh
End Function
;~IDEal Editor Parameters:
;~F#15#81#8E
;~C#BlitzPlus